//  Modified by Curtis Krauskopf (the Database Managers, Inc., www.decompile.com)
//  for wider distribution and to apply modern programming practices while trying
//  to maintain the spirit of the original library.

#include "JStack.h"

template <class Etype>
Java::Stack<Etype>::Stack()
{
    m_pTOS = NULL;
}

template <class Etype>
Java::Stack<Etype>::~Stack()
{
    clear();
}

template <class Etype>
const Etype &
Java::Stack<Etype>::peek() const
throw (char *)
{
    if ( m_pTOS == NULL )
#ifdef JAVALIB_USE_CERR
       cerr << "Java::Stack is Empty" << endl;
       exit(1);
#else
        throw "Java::Stack is Empty";
#endif

    return m_pTOS->value;
}


template <class Etype>
Etype
Java::Stack<Etype>::pop()
throw (char *)
{
    if ( m_pTOS == NULL )
#ifdef JAVALIB_USE_CERR
       cerr << "Java::Stack is Empty" << endl;
       exit(1);
#else
        throw "Java::Stack is Empty";
#endif

    node* old = m_pTOS;
    m_pTOS = m_pTOS->next;

    const Etype temp = old->value;
    delete old;

    return temp;
}

template <class Etype>
void
Java::Stack<Etype>::clear()
{
    while ( m_pTOS != NULL )
    {
        node* old = m_pTOS;
        m_pTOS = m_pTOS->next;
        delete old;
    }
}

template <class Etype>
void
Java::Stack<Etype>::push( const Etype &item )
{
    m_pTOS = new node( item, m_pTOS );
}

template <class Etype>
int
Java::Stack<Etype>::search( const Etype &item ) const
{
    const node* pJStack = m_pTOS;
    for( int count = 1; pJStack != NULL; count++ )
    {
        if ( pJStack->value == item )
            return count;
        pJStack = pJStack->next;
    }

    return -1;
}


 